%define mpiimpl openmpi
%define mpidir %_libexecdir/%mpiimpl

%define ver 5.4
Name: vtk
Version: %ver.0
Release: alt4
Summary: The Visualization Toolkit, an Object-Oriented Approach to 3D Graphics
License: BSD-like
Group: Development/Tools
Url: http://www.vtk.org/
Packager: Eugeny A. Rostovtsev (REAL) <real at altlinux.org>
%setup_python_module vtk

Source: http://www.vtk.org/files/release/5.4/vtk-5.4.0.tar.gz
Source3: examples
Source4: CMakeCache.txt

Requires: lib%name = %version-%release

BuildRequires(pre): rpm-build-tcl
BuildPreReq: gcc-c++ tcl-devel tk-devel cmake libGLU-devel libXt-devel
BuildPreReq: %mpiimpl-devel libMySQL5.1-devel postgresql8.3-devel boost-devel
BuildPreReq: libfreetype-devel libnetcdf-mpi-devel libjpeg-devel
BuildPreReq: libxml2-devel libexpat-devel libftgl-devel libpng-devel
BuildPreReq: libtiff-devel zlib-devel libhdf5-mpi-devel libsqlite3-devel
BuildPreReq: doxygen graphviz libqt4-devel libgsl-devel ctest
BuildPreReq: libbfd-devel proj-devel chrpath
BuildPreReq: %name-data >= %version
BuildPreReq: python-devel = %__python_version

%description
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

%package -n lib%name
Summary: Shared libraries of The Visualization Toolkit (VTK)
Group: System/Libraries

%description -n lib%name
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package contains shared libraries of VTK.

%package -n lib%name-devel
Summary: Development files of The Visualization Toolkit (VTK)
Group: Development/C++
Requires: %name = %version-%release
Requires: %name-tcl = %version-%release
Requires: lib%name = %version-%release

%description -n lib%name-devel
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package contains development files of VTK.

%package qt4-designer-plugin
Summary: The Visualization Toolkit (VTK) plugin for Qt4
Group: Development/KDE and QT
Requires: lib%name = %version-%release
Requires: qt4-designer

%description qt4-designer-plugin
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package contains VTK plugin for Qt4 Designer.

%package doc
Summary: Documentation for The Visualization Toolkit (VTK)
Group: Development/Documentation
BuildArch: noarch

%description doc
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package contains documentation for VTK.

%package tcl
Summary: The Visualization Toolkit (VTK) TCL bindings
Group: Development/Tcl
Requires: %name = %version-%release
Requires: lib%name = %version-%release
Requires: lib%name-tcl = %version-%release
%add_tcl_lib_path %_tcldatadir/%name-%ver
Provides: tcl(vtkbase) = %ver
Provides: tcl(vtkcommon) = %ver
Provides: tcl(vtkfiltering) = %ver
Provides: tcl(vtkgraphics) = %ver
Provides: tcl(vtkhybrid) = %ver
Provides: tcl(vtkimaging) = %ver
Provides: tcl(vtkio) = %ver
Provides: tcl(vtkrendering) = %ver
Provides: tcl(vtkwidgets) = %ver

%description tcl
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package provides TCL bindings to VTK.

%package -n lib%name-tcl
Summary: Shared libraries of VTK-TCL bindings
Group: System/Libraries
Requires: lib%name = %version-%release

%description -n lib%name-tcl
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package contains shared libraries for TCL bindings to VTK.

%package -n lib%name-tcl-devel
Summary: Development files of VTK-TCL bindings
Group: Development/Tcl
Requires: lib%name-devel = %version-%release
Requires: lib%name-tcl = %version-%release

%description -n lib%name-tcl-devel
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package contains development files for TCL bindings to VTK.

%package python
Summary: The Visualization Toolkit (VTK) Python bindings
Group: Development/Python
Requires: %name = %version-%release
Requires: lib%name = %version-%release
Requires: lib%name-python = %version-%release
Requires: python-module-%name = %version-%release

%description python
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package provides Python bindings to VTK.

%package -n lib%name-python
Summary: The Visualization Toolkit (VTK) Python shared libraries
Group: System/Libraries
Requires: lib%name = %version-%release

%description -n lib%name-python
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package contains Python shared libraries of VTK.

%package -n lib%name-python-devel
Summary: The Visualization Toolkit (VTK) Python development files
Group: Development/Python
Requires: lib%name-python = %version-%release

%description -n lib%name-python-devel
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package contains Python development files of VTK.

%package -n python-module-%name
Summary: The Visualization Toolkit (VTK) Python bindings
Group: Development/Python
Requires: lib%name-python = %version-%release
Requires: python-module-pygtkglext
%add_python_req_skip gtk.GDK gtk.gtkgl
%py_requires gtk

%description -n python-module-%name
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package provides Python bindings to VTK.

%package examples
Summary: The Visualization Toolkit (VTK) examples
Group: Development/Tools
Requires: %name = %version-%release
Requires: %name-tcl = %version-%release
Requires: %name-data >= %version

%description examples
VTK is an open-source software system for image processing, 3D graphics, volume
rendering and visualization. VTK includes many advanced algorithms (e.g.,
surface reconstruction, implicit modelling, decimation) and rendering techniques
(e.g., hardware-accelerated volume rendering, LOD control).

This package contains VTK examples. For correct work of all examples and tests
You need set environment variable VTK_DATA_ROOT=/usr/share/vtk-%ver.

%prep
%setup
install -m644 %SOURCE3 %SOURCE4 .

%build
mpi-selector --set %mpiimpl
source %mpidir/bin/mpivars.sh
export VTK_DATA_ROOT=%_datadir/%name-%ver
cmake . -DCMAKE_INSTALL_PREFIX=%prefix

tar -cjf src.tar.bz2 Examples

%make_build

%install
export VTK_DATA_ROOT=%_datadir/%name-%ver
source %mpidir/bin/mpivars.sh
%makeinstall_std

install -d %buildroot%_libdir
install -d %buildroot%_docdir/%name-%ver
install -d %buildroot%_datadir/%name-%ver-examples
install -d %buildroot%_libexecdir/qt4
install -d %buildroot%_tcldatadir/%name%ver

pushd %buildroot%_libexecdir/%name-%ver
mv doc/verdict %buildroot%_docdir/%name-%ver/
rmdir doc
for i in $(ls libvtk*TCL.so); do
	ln -s %_libdir/$i.%ver %buildroot%_tcldatadir/%name%ver/$i
done
mv *.so* %buildroot%_libdir/
mv pkgIndex.tcl tcl %buildroot%_tcldatadir/%name%ver/
popd
mv %buildroot%prefix/plugins %buildroot%_libexecdir/qt4/

for i in $(cat examples); do
	chrpath -r %mpidir/lib bin/$i
	install -m755 bin/$i %buildroot%_bindir
done
install -m644 src.tar.bz2 %buildroot%_datadir/%name-%ver-examples

pushd Wrapping/Python
%__python setup.py build
CFLAGS="%optflags" %__python setup.py install \
	--root=%buildroot --optimize=2
popd

%ifarch x86_64
install -d %buildroot%python_sitelibdir
mv %buildroot%_libexecdir/python%__python_version/site-packages/* \
	%buildroot%python_sitelibdir/
%endif

%post -n lib%name
if [ -h %_libexecdir/%name ]; then
	rm -f %_libexecdir/%name
fi
ln -s %_libexecdir/%name-%ver %_libexecdir/%name

%postun -n lib%name
rm -f %_libexecdir/%name

%files
%doc Copyright.txt README.html
%_bindir/lproj
%_bindir/pvtk
%_bindir/vtk
%_bindir/vtkEncodeString

%files -n lib%name
%_libdir/*.so.*
%exclude %_libdir/*TCL.so.*
%exclude %_libdir/*Python*.so.*
%dir %_libexecdir/%name-%ver

%files -n lib%name-devel
%_libdir/*.so
%exclude %_libdir/*TCL.so
%exclude %_libdir/*Python*.so
%_includedir/%name-%ver
%exclude %_includedir/%name-%ver/*Tcl*
%exclude %_includedir/%name-%ver/*Python*
%_libexecdir/%name-%ver/*
%exclude %_libexecdir/%name-%ver/testing/*.py*
%exclude %_libexecdir/%name-%ver/CMake/*TCL*
%exclude %_libexecdir/%name-%ver/CMake/*Tcl*
%exclude %_libexecdir/%name-%ver/CMake/*Python*

%files doc
%_docdir/%name-%ver

%files tcl
%_bindir/*Tcl*
%_tcldatadir/%name%ver

%files -n lib%name-tcl
%_libdir/*TCL.so.*

%files -n lib%name-tcl-devel
%_libdir/*TCL.so
%_libexecdir/%name-%ver/CMake/*TCL*
%_libexecdir/%name-%ver/CMake/*Tcl*
%_includedir/%name-%ver/*Tcl*

%files examples
%_bindir/*
%exclude %_bindir/lproj
%exclude %_bindir/pvtk
%exclude %_bindir/vtk
%exclude %_bindir/vtkEncodeString
%exclude %_bindir/*Tcl*
%exclude %_bindir/*python*
%exclude %_bindir/*Python*
%_datadir/%name-%ver-examples

%files qt4-designer-plugin
%_libexecdir/qt4/plugins/designer/*

%files python
%_bindir/*python*
%_bindir/*Python*
%_libexecdir/%name-%ver/testing/*.py*

%files -n lib%name-python
%_libdir/*Python*.so.*

%files -n lib%name-python-devel
%_libdir/*Python*.so
%_includedir/%name-%ver/*Python*
%_libexecdir/%name-%ver/CMake/*Python*

%files -n python-module-%name
%python_sitelibdir/*

%changelog
* Thu Jul 09 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 5.4.0-alt4
- Enabled Python module

* Tue Jun 23 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 5.4.0-alt3
- Rebuild with changed libpng12

* Fri Jun 05 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 5.4.0-alt2
- Fixed directory layout for TCL wrappers

* Thu Jun 04 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 5.4.0-alt1
- Initial build for Sisyphus

